
/*
 * Copyright (C) 2010-2016 Oracle Corporation
 *
 * This file is part of the VirtualBox SDK, as available from
 * http://www.virtualbox.org.  This library is free software; you can
 * redistribute it and/or modify it under the terms of the GNU Lesser General
 * Public License as published by the Free Software Foundation, in version 2.1
 * as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * FsObjMoveFlag.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_6_1;

import org.virtualbox_6_1.jaxws.*;
import javax.xml.ws.*;

/**
File moving flags.
Interface ID: <tt>{2450A05D-80C6-4C96-9A17-94D73293FF86}</tt>
*/
public enum FsObjMoveFlag
{

/**
No flag set.
*/
    None(0),

/**
Replace the destination file, symlink, etc if it exists, however this
does not allow replacing any directories.
*/
    Replace(1),

/**
Follow symbolic links in the final components or not (only applied to
the given source and target paths, not to anything else).
*/
    FollowLinks(2),

/**
Allow moving directories accross file system boundraries. Because it
is could be a big undertaking, we require extra assurance that we
should do it when requested.
*/
    AllowDirectoryMoves(4);

    private final int value;

    FsObjMoveFlag(int v)
    {
        value = v;
    }

    public int value()
    {
        return value;
    }

    public static FsObjMoveFlag fromValue(long v)
    {
        for (FsObjMoveFlag c: FsObjMoveFlag.values())
        {
            if (c.value == (int)v)
            {
                return c;
            }
        }
        throw new IllegalArgumentException(Long.toString(v));
    }

    public static FsObjMoveFlag fromValue(String v)
    {
        return valueOf(FsObjMoveFlag.class, v);
    }
}

